#ifndef BUTTON_h
#define BUTTON_h

#include <Arduino.h>

class Button
{

private:

	int _pin;
	int _id;

	bool _state;

	volatile bool _inputFlag = false;
	bool _changeFlag = false;

	bool _pressedFlag = false;
	bool _holdFlag = false;

	unsigned long _previousTimer;

	int _clickInterval = 1000;
	int _holdInterval = 1000;
	int _repeatInterval = 1000;

	void (*_cb)(Button*, uint8_t, bool);     // Callback function

	/**
	   @brief What does this do?
	 */
	bool _read();

	/**
	   @brief What does this do?
	 */
	void _setClickInterval(int x);

	/**
	   @brief What does this do?
	 */
	void _setHoldInterval(int x);

	/**
	   @brief What does this do?
	 */
	void _setRepeatInterval(int x);

public:

	// Public members:

	static const uint8_t kEventPressed = 0;            // Button was pressed
	static const uint8_t kEventReleased = 1;           // Button was released
	static const uint8_t kEventClicked = 2;            // Button was clicked (pressed and released within _clickInterval)
	static const uint8_t kEventHeld = 3;        // Button was held down for longer than _holdInterval
	static const uint8_t kEventTick = 4;      // Event released every _repeatInterval when button held

	// Public functions:

	Button(int pin, int id = 99);
	/**
	   @brief What does this do?
	 */
	void initInterrupts(void (*function)());
	/**
	   @brief What does this do?
	 */
	void setEventHandler(void (*function)(Button*, uint8_t, bool));
	/**
	   @brief What does this do?
	 */
	bool getState();
	/**
	   @brief What does this do?
	 */
	int getId();
	/**
	   @brief What does this do?
	 */
	int getClickInterval();
	/**
	   @brief What does this do?
	 */
	int getHoldInterval();
	/**
	   @brief What does this do?
	 */
	int getRepeatInterval();
	/**
	   @brief What does this do?
	 */
	void check();
  /**
      @brief What does this do?
  */
  void 	ICACHE_RAM_ATTR tick();

};

#endif
